package com.malk.lanyun.service;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;
import java.util.Map;

public interface TimerService {

    /**
     * 月度定额更新
     */
    String updateYuedudinge();

    /**
     * 每月月初更新业主产值每月累计
     */
    void updateBigOut();

    /**
     * 刷新版本数据
     */
    void fresh();

    /**
     * 采购订单档案导出
     * @param data 前端传流程ID
     * @param response 响应头
     * @param request 请求头
     */
    void execlExport(Map data, HttpServletResponse response, HttpServletRequest request);

    /**
     * 每月月初发起风控绩效流程
     */
    void monthRiskMerits();

    /**
     * 分组求和各项目经营分析
     * @param data 分组条件
     */
    Map<String, Object> projectAnalysisGroup(Map<String, Object> data);

    /**
     * 每日同步各项目分析报表
     */
    void insertAnalysisList();

    /**
     * 日常物耗申请单中采购专员审批后更新字段初始物耗费用总计
     * @param
     */
    void updateMaterialConsumption(String formInstId,Double firstCost,Double nowCost);


    /**
     * 催款函
     */
    void sendReminderLetter();

    /**
     * 刷新版本
     * @param data 实例ID或表单ID
     */
    void freshVersion(Map<String,Object> data);

    /**
     * 日常物耗申请单中采购专员提交占用项目点月度物耗定额
     * @param projectCode 项目点编号
     * @param date 日期文本
     * @param firstCost 初始物耗费用合计
     * @param nowCost 本次物耗
     */
    void updateMaterialProject(String projectCode, String date, Double firstCost, Double nowCost, String formInstId);

    /**
     * 定时更新本周未出库项目数
     */
    void projectUnshipped();

    /**
     * 每日定时跑批本周到当天的入职离职人数，和当天在职人数
     */
    void monthPersonnelMatters();

    /**
     * 项目点档案点编辑保存后，更新是否补充字段为是
     * @param data 传参
     */
    void updateIsSupply(Map data);

    /**
     * 查找项目点档案一个项目编号下所有项目点是否补充
     * @param
     */
    Map<String, Boolean> selectIsSupply(String projectCode);

    Map<String, Boolean> testSelectIsSupply(HttpServletRequest request);

    void updateAnalysis(Map<String,Object> data);

    List<Map> checkoutStatus(Map<String, Object> data);
    /**
     * 日常物耗申请单中发起节点获取首条供应商价目表单价
     * @param
     */
    void updateDailyPrice(String formInstId);

    /**
     * 查询正式数据库NC测试表
     * @param data
     * @return
     */
    Map<String, Object> testProjectAnalysisGroup(Map<String, Object> data);

    void getProject(String formInstId, String projectCode, String monthAmount);

    void updateOutputPredict();


    /**
     * OA撤销流程回调终止宜搭流程实例
     * @param processInstanceId
     */
    void terminateDataById(String processInstanceId);

    void updateYearPredict();

    void updateUseCar();
}
