package com.malk.lanyun.service.impl;

import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSON;
import com.malk.lanyun.entity.MySqlBean;
import com.malk.lanyun.entity.SqlServerBean;
import com.malk.lanyun.service.NCService;
import com.malk.server.aliwork.YDConf;
import com.malk.server.aliwork.YDParam;
import com.malk.service.aliwork.YDClient;
import com.malk.service.aliwork.YDService;
import com.malk.service.dingtalk.DDClient;
import com.malk.service.dingtalk.DDClient_Personnel;
import com.malk.utils.UtilDateTime;
import com.malk.utils.UtilMap;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.sql.*;
import java.time.LocalDate;
import java.time.Year;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

@Service
@Slf4j
public class NCServiceImpl implements NCService {

    @Autowired
    private YDClient ydClient;

    @Autowired
    private SqlServerBean sqlBean;
    @Autowired
    private MySqlBean mySqlBean;
    @Autowired
    private YDService ydService;
    @Autowired
    private DDClient_Personnel ddClientPersonnel;
    @Autowired
    private DDClient ddClient;
    @Value("${dingtalk.agentId}")
    private Long agentId;
    // 获取当前日期
    LocalDate lastMonth = LocalDate.now().minusMonths(1);
    //本月
//    LocalDate lastMonth = LocalDate.now();
    DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");
    @Override
    public void getNcInfo() {
        // 获取上月年，月
        int year = lastMonth.getYear();
        String month = String.format("%02d",lastMonth.getMonthValue()) ;
        deleteMonthDate("FORM-D7FAD41DA72041ED96431F4219F082B7DTNH","textField_m0dkzhwo", String.valueOf(year),month);

        Connection connection = null;
        Statement statement = null;
        ResultSet resultSet = null;
        try {
            // 加载 JDBC 驱动
            Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
            // 建立连接
            connection = DriverManager.getConnection(sqlBean.getUrl(), sqlBean.getUsername(), sqlBean.getPassword());
            // 创建 Statement 对象
            statement = connection.createStatement();

            // 执行查询
            String sql = "SELECT b.adjustperiod AS adjustperiod, b.pk_accasoa AS pk_accasoa, a.name AS accasoa_name, SUM ( b.creditamount ) AS creditamount             FROM gl_detail b JOIN bd_accasoa a ON b.pk_accasoa = a.pk_accasoa WHERE  b.yearv = "+year+"\n AND b.adjustperiod = "+ month +
                    "            AND b.accountcode IN ( '50010101', '500102', '500103', '500117', '500114', '500115', '500118', '500119', '500109', '500133' )             AND b.pk_accountingbook IN ( SELECT pk_accountingbook FROM org_accountingbook WHERE code IN ( 'A01-0004', 'A02-0004', 'A03-0004', 'A04-0004', 'A05-0004', 'A06-0004', 'A10-0004', 'A11-0004' ) )             GROUP BY b.adjustperiod,  b.pk_accasoa, a.name";

            resultSet = statement.executeQuery(sql);

            // 处理结果集
            while (resultSet.next()) {
                Map hashMap = new HashMap();

                String yearAndNonth = year +"-"+resultSet.getString("adjustperiod");
                hashMap.put("dateField_m0dkzhwp", UtilDateTime.parse(yearAndNonth,"yyyy-MM"));
                hashMap.put("textField_m0dkzhwo", yearAndNonth);
                hashMap.put("textField_m0dkzhwu",resultSet.getString("pk_accasoa"));
                hashMap.put("textField_m0dkzhwv",resultSet.getString("accasoa_name"));
                hashMap.put("numberField_m0dkzhx1",resultSet.getBigDecimal("creditamount"));

                log.info("yearv："+UtilDateTime.parse(yearAndNonth,"yyyy-MM"));
                log.info("periodv："+resultSet.getString("pk_accasoa"));
                log.info("periodv："+resultSet.getString("accasoa_name"));
                log.info("creditamount："+resultSet.getBigDecimal("creditamount"));

                //写入月度项目经营情况
                ydClient.operateData(YDParam.builder()
                        .appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formUuid("FORM-D7FAD41DA72041ED96431F4219F082B7DTNH")
                        .formDataJson(JSON.toJSONString(hashMap))
                        .build(), YDConf.FORM_OPERATION.create);
            }
        } catch (Exception e) {
            log.info("数据库连接异常"+e.toString());
            e.printStackTrace();
        } finally {
            // 关闭资源
            try {
                if (resultSet != null) resultSet.close();
                if (statement != null) statement.close();
                if (connection != null) connection.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    public void getNcCgInfo() {
        // 获取当前年
        int year = lastMonth.getYear();
        String month = String.format("%02d",lastMonth.getMonthValue()) ;
        deleteMonthDate("FORM-EC67BCB875264EE9AE25C9D663568CAFCYU6","textField_m0dkzhwo", String.valueOf(year),month);

        Connection connection = null;
        Statement statement = null;
        ResultSet resultSet = null;
        try {
            // 加载 JDBC 驱动
            Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
            // 建立连接
            connection = DriverManager.getConnection(sqlBean.getUrl(), sqlBean.getUsername(), sqlBean.getPassword());

            // 创建 Statement 对象
            statement = connection.createStatement();

            // 测试sql 执行查询
            String sql = "SELECT b.adjustperiod AS adjustperiod, b.pk_accasoa AS pk_accasoa,a.name AS accasoa_name, SUM ( b.creditamount ) AS creditamount             FROM gl_detail b JOIN bd_accasoa a ON b.pk_accasoa = a.pk_accasoa WHERE b.yearv = "+year+" AND b.adjustperiod = "+ month +
                    "            AND b.accountcode IN ( '500114', '500115' )             AND b.pk_accountingbook IN ( SELECT pk_accountingbook FROM org_accountingbook WHERE code IN ( 'A01-0004', 'A02-0004', 'A03-0004', 'A04-0004', 'A05-0004', 'A06-0004', 'A10-0004', 'A11-0004' ))             GROUP BY b.adjustperiod,  b.pk_accasoa,  a.name";


            resultSet = statement.executeQuery(sql);

            while (resultSet.next()) {
                Map hashMap = new HashMap();

                String yearAndNonth = year +"-"+resultSet.getString("adjustperiod");
                hashMap.put("dateField_m0dkzhwp", UtilDateTime.parse(yearAndNonth,"yyyy-MM"));
                hashMap.put("textField_m0dkzhwo", yearAndNonth);
                hashMap.put("textField_m0dkzhwu",resultSet.getString("pk_accasoa"));
                hashMap.put("textField_m0dkzhwv",resultSet.getString("accasoa_name"));
                hashMap.put("numberField_m0dkzhx1",resultSet.getBigDecimal("creditamount"));

                log.info("yearv："+UtilDateTime.parse(yearAndNonth,"yyyy-MM"));
                log.info("periodv："+resultSet.getString("pk_accasoa"));
                log.info("periodv："+resultSet.getString("accasoa_name"));
                log.info("creditamount："+resultSet.getBigDecimal("creditamount"));

                ydClient.operateData(YDParam.builder()
                        .appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formUuid("FORM-EC67BCB875264EE9AE25C9D663568CAFCYU6")
                        .formDataJson(JSON.toJSONString(hashMap))
                        .build(), YDConf.FORM_OPERATION.create);
            }
        } catch (Exception e) {
            log.info("数据库连接异常"+e.toString());
            e.printStackTrace();

        } finally {
            // 关闭资源
            try {
                if (resultSet != null) resultSet.close();
                if (statement != null) statement.close();
                if (connection != null) connection.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    /**
     * 大业主项目
     */
    @Override
    public void getNcCost() {
        // 获取当前年
        int year = lastMonth.getYear();
        String month = String.format("%02d",lastMonth.getMonthValue()) ;
        deleteMonthDate("FORM-87BF51F1E54D4D73A987939613D07BD5ZZE9","textField_m0dkzhwo", String.valueOf(year),month);

        Connection connection = null;
        Statement statement = null;
        ResultSet resultSet = null;
        try {
            // 加载 JDBC 驱动
            Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
            // 建立连接
            connection = DriverManager.getConnection(sqlBean.getUrl(), sqlBean.getUsername(), sqlBean.getPassword());

            // 创建 Statement 对象
            statement = connection.createStatement();

            // 测试sql 执行查询
            String sql = "SELECT b.adjustperiod AS adjustperiod, b.pk_accasoa AS pk_accasoa,a.name AS accasoa_name, SUM ( b.creditamount ) AS creditamount             FROM gl_detail b JOIN bd_accasoa a ON b.pk_accasoa = a.pk_accasoa WHERE b.yearv = "+year+" AND b.adjustperiod = "+ month +
                    "            AND b.accountcode IN ( '500114', '500115' )             AND b.pk_accountingbook IN ( SELECT pk_accountingbook FROM org_accountingbook WHERE code IN ( 'A01-0004', 'A02-0004', 'A03-0004', 'A04-0004', 'A05-0004', 'A06-0004', 'A10-0004', 'A11-0004' ))             GROUP BY b.adjustperiod,  b.pk_accasoa,  a.name";


            resultSet = statement.executeQuery(sql);

            while (resultSet.next()) {
                Map hashMap = new HashMap();

                String yearAndNonth = year +"-"+resultSet.getString("adjustperiod");
                hashMap.put("dateField_m0dkzhwp", UtilDateTime.parse(yearAndNonth,"yyyy-MM"));
                hashMap.put("textField_m0dkzhwo", yearAndNonth);
                hashMap.put("textField_m0dkzhwu",resultSet.getString("pk_accasoa"));
                hashMap.put("textField_m0dkzhwv",resultSet.getString("accasoa_name"));
                hashMap.put("textField_m0eudqp0","大业主项目ID");
                hashMap.put("textField_m0eudqp2","大业主项目名称");
                hashMap.put("numberField_m0dkzhx1",resultSet.getBigDecimal("creditamount"));

                log.info("yearv："+UtilDateTime.parse(yearAndNonth,"yyyy-MM"));
                log.info("periodv："+resultSet.getString("pk_accasoa"));
                log.info("periodv："+resultSet.getString("accasoa_name"));
                log.info("creditamount："+resultSet.getBigDecimal("creditamount"));

                ydClient.operateData(YDParam.builder()
                        .appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formUuid("FORM-87BF51F1E54D4D73A987939613D07BD5ZZE9")
                        .formDataJson(JSON.toJSONString(hashMap))
                        .build(), YDConf.FORM_OPERATION.create);
            }
        } catch (Exception e) {
            log.info("数据库连接异常"+e.toString());
            e.printStackTrace();
        } finally {
            // 关闭资源
            try {
                if (resultSet != null) resultSet.close();
                if (statement != null) statement.close();
                if (connection != null) connection.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    public void getNcCollection() {
        // 获取当前年
        int year = lastMonth.getYear();
        String month = String.format("%02d",lastMonth.getMonthValue()) ;
        deleteMonthDate("FORM-5654B7C22E7546E9BBE7B4EF46DE08BAXZXU","textField_m0dkzhwo", String.valueOf(year),month);

        System.out.println(month);
        Connection connection = null;
        Statement statement = null;
        ResultSet resultSet = null;
        try {
            // 加载 JDBC 驱动
            Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
            // 建立连接
            connection = DriverManager.getConnection(sqlBean.getUrl(), sqlBean.getUsername(), sqlBean.getPassword());

            // 创建 Statement 对象
            statement = connection.createStatement();

            // 测试sql 执行查询
            String sql = "SELECT\n" +
                    "\torg_accountingbook.CODE orgcode,\n" +
                    "\torg_accountingbook.NAME orgname,\n" +
                    "\tbd_account.CODE kmcode,\n" +
                    "\tsubstring( bd_account.CODE, 0, 5 ) kmbm,\n" +
                    "\tbd_accasoa.NAME kmname,\n" +
                    "\tbd_accasoa.dispname KMMC,\n" +
                    "\tISNULL(org_dept.CODE,bd_project.project_code) ccode,\n" +
                    "\tISNULL(org_dept.NAME,bd_project.project_name) cname,\n" +
                    "\torg_dept.CODE bmcode,\n" +
                    "\torg_dept.NAME bmname,\n" +
                    "\tbd_project.project_code xmcode,\n" +
                    "\tbd_project.project_name xmname,\n" +
                    "\tSUM( gl_detail.localdebitamount ) JFFS \n" +
                    "FROM\n" +
                    "\tgl_detail gl_detail\n" +
                    "\tLEFT JOIN gl_docfree1 ON gl_detail.assid = gl_docfree1.assid\n" +
                    "\tLEFT JOIN org_dept ON gl_docfree1.f1 = org_dept.pk_dept\n" +
                    "\tLEFT JOIN bd_project ON gl_docfree1.f10 = bd_project.pk_project\n" +
                    "\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
                    "\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
                    "\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
                    "WHERE\n" +
                    "\tsubstring( bd_account.CODE, 0, 5 ) IN ( '5001', '5301', '6602', '6601', '6001', '6051' ) \n" +
                    "\tAND gl_detail.yearv = '2025' \n" +
                    "\tAND gl_detail.adjustperiod = '04' \n" +
                    "\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
                    "\tAND gl_detail.discardflagv <> 'Y' \n" +
                    "\tAND gl_detail.dr = 0 \n" +
                    "\tAND gl_detail.voucherkindv <> 255 \n" +
                    "\tAND gl_detail.tempsaveflag <> 'Y' \n" +
                    "\tAND gl_detail.voucherkindv <> 5 \n" +
                    "\tAND ( gl_docfree1.F1 <> 'NN/A' OR gl_docfree1.F10 <> 'NN/A' ) \n" +
                    "\tAND 1 = 1 \n" +
                    "GROUP BY\n" +
                    "\tgl_detail.pk_accasoa,\n" +
                    "\tgl_detail.pk_accountingbook,\n" +
                    "\tgl_detail.yearv,\n" +
                    "\torg_dept.CODE,\n" +
                    "\torg_dept.NAME,\n" +
                    "\torg_accountingbook.CODE,\n" +
                    "\torg_accountingbook.NAME,\n" +
                    "\tbd_accasoa.dispname,\n" +
                    "\tbd_account.CODE,\n" +
                    "\tbd_accasoa.NAME,\n" +
                    "\tbd_project.project_code,\n" +
                    "\tbd_project.project_name";


            resultSet = statement.executeQuery(sql);

            while (resultSet.next()) {
                Map hashMap = new HashMap();

                String yearAndNonth = year +"-"+month;
                hashMap.put("dateField_m0dkzhwp", UtilDateTime.parse(yearAndNonth,"yyyy-MM"));
                hashMap.put("textField_m0dkzhwo", yearAndNonth);
                hashMap.put("textField_m0dkzhwu",resultSet.getString("kmcode"));
                hashMap.put("textField_m0dkzhwv",resultSet.getString("kmname"));
                hashMap.put("textField_mbj1j8n2",resultSet.getString("ccode"));
                hashMap.put("textField_m0eudqp0",resultSet.getString("cname"));//部门
                hashMap.put("numberField_m0dkzhx1",resultSet.getBigDecimal("JFFS"));

                ydClient.operateData(YDParam.builder()
                        .appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formUuid("FORM-5654B7C22E7546E9BBE7B4EF46DE08BAXZXU")
                        .formDataJson(JSON.toJSONString(hashMap))
                        .build(), YDConf.FORM_OPERATION.create);
            }
        } catch (Exception e) {
            log.info("数据库连接异常"+e.toString());
            e.printStackTrace();
        } finally {
            // 关闭资源
            try {
                if (resultSet != null) resultSet.close();
                if (statement != null) statement.close();
                if (connection != null) connection.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    public void getNcCollectionOld() {
        // 获取当前年
        int year = lastMonth.getYear();
        String month = String.format("%02d",lastMonth.getMonthValue()) ;
        deleteMonthDate("FORM-5654B7C22E7546E9BBE7B4EF46DE08BAXZXU","textField_m0dkzhwo", String.valueOf(year),month);

        System.out.println(month);
        Connection connection = null;
        Statement statement = null;
        ResultSet resultSet = null;
        try {
            // 加载 JDBC 驱动
            Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
            // 建立连接
            connection = DriverManager.getConnection(sqlBean.getUrl(), sqlBean.getUsername(), sqlBean.getPassword());

            // 创建 Statement 对象
            statement = connection.createStatement();

            // 测试sql 执行查询
            String sql = "SELECT b.adjustperiod AS adjustperiod, b.pk_accasoa AS pk_accasoa,a.name AS accasoa_name, SUM ( b.creditamount ) AS creditamount             FROM gl_detail b JOIN bd_accasoa a ON b.pk_accasoa = a.pk_accasoa WHERE b.yearv = "+year+" AND b.adjustperiod = '"+ month + "'" +
                    "            AND (b.accountcode like '6602%' OR b.accountcode IN ('660101','660103','660104'))" +
                    "            AND b.pk_accountingbook IN ( SELECT pk_accountingbook FROM org_accountingbook WHERE code IN ( 'A01-0004', 'A02-0004', 'A03-0004', 'A04-0004', 'A05-0004', 'A06-0004', 'A10-0004', 'A11-0004' ))             GROUP BY b.adjustperiod,  b.pk_accasoa,  a.name";


            resultSet = statement.executeQuery(sql);

            while (resultSet.next()) {
                Map hashMap = new HashMap();

                String yearAndNonth = year +"-"+resultSet.getString("adjustperiod");
                hashMap.put("dateField_m0dkzhwp", UtilDateTime.parse(yearAndNonth,"yyyy-MM"));
                hashMap.put("textField_m0dkzhwo", yearAndNonth);
                hashMap.put("textField_m0dkzhwu",resultSet.getString("pk_accasoa"));
                hashMap.put("textField_m0dkzhwv",resultSet.getString("accasoa_name"));
                hashMap.put("textField_m0eudqp0","部门");
                hashMap.put("numberField_m0dkzhx1",resultSet.getBigDecimal("creditamount"));

                log.info("yearv："+UtilDateTime.parse(yearAndNonth,"yyyy-MM"));
                log.info("periodv："+resultSet.getString("pk_accasoa"));
                log.info("periodv："+resultSet.getString("accasoa_name"));
                log.info("creditamount："+resultSet.getBigDecimal("creditamount"));


                ydClient.operateData(YDParam.builder()
                        .appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formUuid("FORM-0A7979E168AF494F9AA190F043DCBBC7CW9Z")
                        .formDataJson(JSON.toJSONString(hashMap))
                        .build(), YDConf.FORM_OPERATION.create);
            }
        } catch (Exception e) {
            log.info("数据库连接异常"+e.toString());
            e.printStackTrace();
        } finally {
            // 关闭资源
            try {
                if (resultSet != null) resultSet.close();
                if (statement != null) statement.close();
                if (connection != null) connection.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    public void getSupplierPay() {
        // 获取当前年
        int year = lastMonth.getYear();
        String month = String.format("%02d",lastMonth.getMonthValue()) ;
        deleteMonthDate("FORM-09CDC75CDC6048379567EC87ED6CE7B6T8PP","textField_m0g4itw4", String.valueOf(year),null);

        LocalDate firstDayOfYear = LocalDate.of(year, 1, 1);
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");
        String formattedBeginDate = firstDayOfYear.format(formatter);
        Connection connection = null;
        Statement statement = null;
        ResultSet resultSet = null;

        try {
            // 加载 JDBC 驱动
            Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
            // 建立连接
            connection = DriverManager.getConnection(sqlBean.getUrl(), sqlBean.getUsername(), sqlBean.getPassword());

            // 创建 Statement 对象
            statement = connection.createStatement();

            // 测试sql 执行查询
            String sql = "EXECUTE GetAccountDetails  @IncrementFlag = 0, @BeginDate ='"+formattedBeginDate+"'  ";


            resultSet = statement.executeQuery(sql);

            int count = 1;
            while (resultSet.next()) {
                log.info("第{}次",count);
                Map hashMap = new HashMap();

                String years =resultSet.getString("yearv");
                hashMap.put("dateField_lzuyn2l8", UtilDateTime.parse(years,"yyyy"));
                hashMap.put("textField_m0g4itw4", years);
                hashMap.put("textField_m0g4itw6",resultSet.getString("SupplierCode"));
                hashMap.put("textField_m0g4itw5",resultSet.getString("SupplierName"));
                hashMap.put("numberField_m0g4itw7",resultSet.getBigDecimal("BeginMoney")); //期初金额
                hashMap.put("numberField_m0g4itw8",resultSet.getBigDecimal("InvoiceMoney")); //本年到票金额
                hashMap.put("numberField_m0g4itw9",resultSet.getBigDecimal("PayMoney"));//到票已付累计
                hashMap.put("numberField_m0g4itwb",resultSet.getBigDecimal("SumPayMoney")); //到票未付累计
                hashMap.put("numberField_m0g4itwa",resultSet.getBigDecimal("EstimationMoney")); //暂估金额

                ydClient.operateData(YDParam.builder()
                        .appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formUuid("FORM-09CDC75CDC6048379567EC87ED6CE7B6T8PP")
                        .formDataJson(JSON.toJSONString(hashMap))
                        .build(), YDConf.FORM_OPERATION.create);
                count++;
            }
        } catch (Exception e) {
            log.info("数据库连接异常"+e.toString());
            e.printStackTrace();
        } finally {
            // 关闭资源
            try {
                resultSet.close();
                statement.close();
                connection.close();
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    public void getProjectOperate() {
        int year = lastMonth.getYear();
        String month = String.format("%02d",lastMonth.getMonthValue()) ;
        String yearAndMonth = year +"-"+month;
        LocalDate now = LocalDate.now();
        int thisYear = now.getYear();
        String thisStrMonth = String.format("%02d",now.getMonthValue());
        String thisMonth = year + "-" + month;


        Connection connection = null;
        Statement statement = null;
        ResultSet resultSet = null;
        Connection mysqlCon = null;
        PreparedStatement[] ps = {null};
        try {
            // 加载 JDBC 驱动
            Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
            // 建立连接
            connection = DriverManager.getConnection(sqlBean.getUrl(), sqlBean.getUsername(), sqlBean.getPassword());
            mysqlCon = DriverManager.getConnection(mySqlBean.getUrl(), mySqlBean.getUsername(), mySqlBean.getPassword());

            // 创建 Statement 对象
            statement = connection.createStatement();

            //获取生产成本-工资
            String sql = "SELECT\n" +
                    "\tbd_project.project_code xmcode,\n" +
                    "\tbd_project.project_name xmname,\n" +
                    "\tgl_detail.yearv yearv,\n" +
                    "\tgl_detail.adjustperiod monthv,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localdebitamount ELSE 0 END ) JFFS,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localcreditamount ELSE 0 END ) DFFS \n" +
                    "FROM\n" +
                    "\tgl_detail gl_detail\n" +
                    "\tLEFT JOIN gl_docfree1 ON gl_detail.assid = gl_docfree1.assid\n" +
                    "\tLEFT JOIN org_dept ON gl_docfree1.f1 = org_dept.pk_dept\n" +
                    "\tLEFT JOIN bd_project ON gl_docfree1.f10 = bd_project.pk_project\n" +
                    "\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
                    "\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
                    "\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
                    "WHERE\n" +
                    "\tbd_account.CODE IN ( '50010101', '500103', '500102', '500117' ) \n" +
                    "\tAND gl_detail.yearv = '"+thisYear+"' \n" +
                    "\tAND gl_detail.adjustperiod = '"+thisStrMonth+"' \n" +
                    "\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
                    "\tAND gl_detail.discardflagv <> 'Y' \n" +
                    "\tAND gl_detail.dr = 0 \n" +
                    "\tAND gl_detail.voucherkindv <> 255 \n" +
                    "\tAND gl_detail.tempsaveflag <> 'Y' \n" +
                    "\tAND gl_detail.voucherkindv <> 5 \n" +
                    "\tAND ( gl_docfree1.F1 <> 'NN/A' OR gl_docfree1.F10 <> 'NN/A' ) \n" +
                    "\tAND 1 = 1 \n" +
                    "GROUP BY\n" +
                    "\tgl_detail.yearv,\n" +
                    "\tgl_detail.adjustperiod,\n" +
                    "\tbd_project.project_code,\n" +
                    "\tbd_project.project_name \n" +
                    "ORDER BY\n" +
                    "\txmcode ASC ";

            resultSet = statement.executeQuery(sql);

            List<Map<String,Object>> personCostList = new ArrayList<>();
            while (resultSet.next()) {
                HashMap<String, Object> personCost = new HashMap<>();
                personCost.put("xmcode",resultSet.getString("xmcode"));
                personCost.put("xmname",resultSet.getString("xmname"));
                personCost.put("person_cost_compute",resultSet.getString("JFFS"));
                personCostList.add(personCost);
            }
            log.info("personCostList:{}",personCostList.size());
            //获取生产成本-材料费
            sql = "SELECT\n" +
                    "\tbd_project.project_code xmcode,\n" +
                    "\tbd_project.project_name xmname,\n" +
                    "\tgl_detail.yearv yearv,\n" +
                    "\tgl_detail.adjustperiod monthv,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localdebitamount ELSE 0 END ) JFFS,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localcreditamount ELSE 0 END ) DFFS \n" +
                    "FROM\n" +
                    "\tgl_detail gl_detail\n" +
                    "\tLEFT JOIN gl_docfree1 ON gl_detail.assid = gl_docfree1.assid\n" +
                    "\tLEFT JOIN org_dept ON gl_docfree1.f1 = org_dept.pk_dept\n" +
                    "\tLEFT JOIN bd_project ON gl_docfree1.f10 = bd_project.pk_project\n" +
                    "\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
                    "\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
                    "\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
                    "WHERE\n" +
                    "\tbd_account.CODE IN ( '500114','500115' ) \n" +
                    "\tAND gl_detail.yearv = '"+year+"' \n" +
                    "\tAND gl_detail.adjustperiod = '"+month+"' \n" +
                    "\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
                    "\tAND gl_detail.discardflagv <> 'Y' \n" +
                    "\tAND gl_detail.dr = 0 \n" +
                    "\tAND gl_detail.voucherkindv <> 255 \n" +
                    "\tAND gl_detail.tempsaveflag <> 'Y' \n" +
                    "\tAND gl_detail.voucherkindv <> 5 \n" +
                    "\tAND ( gl_docfree1.F1 <> 'NN/A' OR gl_docfree1.F10 <> 'NN/A' ) \n" +
                    "\tAND 1 = 1 \n" +
                    "GROUP BY\n" +
                    "\tgl_detail.yearv,\n" +
                    "\tgl_detail.adjustperiod,\n" +
                    "\tbd_project.project_code,\n" +
                    "\tbd_project.project_name \n" +
                    "ORDER BY\n" +
                    "\txmcode ASC ";

            resultSet = statement.executeQuery(sql);
            List<Map<String,Object>> materialList = new ArrayList<>();
            while (resultSet.next()) {
                HashMap<String, Object> personCost = new HashMap<>();
                personCost.put("xmcode",resultSet.getString("xmcode"));
                personCost.put("xmname",resultSet.getString("xmname"));
                personCost.put("material_compute",resultSet.getString("JFFS"));
                materialList.add(personCost);
            }
            log.info("materialList:{}",materialList.size());

            //获取生产成本-折修租劳
            sql = "SELECT\n" +
                    "\tbd_project.project_code xmcode,\n" +
                    "\tbd_project.project_name xmname,\n" +
                    "\tgl_detail.yearv yearv,\n" +
                    "\tgl_detail.adjustperiod monthv,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localdebitamount ELSE 0 END ) JFFS,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localcreditamount ELSE 0 END ) DFFS \n" +
                    "FROM\n" +
                    "\tgl_detail gl_detail\n" +
                    "\tLEFT JOIN gl_docfree1 ON gl_detail.assid = gl_docfree1.assid\n" +
                    "\tLEFT JOIN org_dept ON gl_docfree1.f1 = org_dept.pk_dept\n" +
                    "\tLEFT JOIN bd_project ON gl_docfree1.f10 = bd_project.pk_project\n" +
                    "\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
                    "\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
                    "\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
                    "WHERE\n" +
                    "\tbd_account.CODE IN ( '500118','500119','500120','500121' ) \n" +
                    "\tAND gl_detail.yearv = '"+year+"' \n" +
                    "\tAND gl_detail.adjustperiod = '"+month+"' \n" +
                    "\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
                    "\tAND gl_detail.discardflagv <> 'Y' \n" +
                    "\tAND gl_detail.dr = 0 \n" +
                    "\tAND gl_detail.voucherkindv <> 255 \n" +
                    "\tAND gl_detail.tempsaveflag <> 'Y' \n" +
                    "\tAND gl_detail.voucherkindv <> 5 \n" +
                    "\tAND ( gl_docfree1.F1 <> 'NN/A' OR gl_docfree1.F10 <> 'NN/A' ) \n" +
                    "\tAND 1 = 1 \n" +
                    "GROUP BY\n" +
                    "\tgl_detail.yearv,\n" +
                    "\tgl_detail.adjustperiod,\n" +
                    "\tbd_project.project_code,\n" +
                    "\tbd_project.project_name \n" +
                    "ORDER BY\n" +
                    "\txmcode ASC ";

            resultSet = statement.executeQuery(sql);
            List<Map<String,Object>> repairList = new ArrayList<>();
            while (resultSet.next()) {
                HashMap<String, Object> personCost = new HashMap<>();
                personCost.put("xmcode",resultSet.getString("xmcode"));
                personCost.put("xmname",resultSet.getString("xmname"));
                personCost.put("material_compute",resultSet.getString("JFFS"));
                repairList.add(personCost);
            }
            log.info("materialList:{}",materialList.size());

            //获取5001科目总生产成本
            sql = "SELECT\n" +
                    "\tA.yearv,\n" +
                    "\tA.monthv,\n" +
                    "\tA.xmcode,\n" +
                    "\tA.xmname,\n" +
                    "\tsum( A.JFFS ) JFFS,\n" +
                    "\tsum( A.DFFS ) DFFS \n" +
                    "FROM\n" +
                    "\t(\n" +
                    "\tSELECT\n" +
                    "\t\tgl_detail.yearv yearv,\n" +
                    "\t\tgl_detail.adjustperiod monthv,\n" +
                    "\t\torg_accountingbook.CODE orgcode,\n" +
                    "\t\torg_accountingbook.NAME orgname,\n" +
                    "\t\tsubstring( bd_account.CODE, 0, 5 ) kmbm,\n" +
                    "\t\tbd_accasoa.dispname,\n" +
                    "\t\torg_dept.CODE bmcode,\n" +
                    "\t\torg_dept.NAME bmname,\n" +
                    "\t\tbd_project.project_code xmcode,\n" +
                    "\t\tbd_project.project_name xmname,\n" +
                    "\t\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localdebitamount ELSE 0 END ) JFFS,\n" +
                    "\t\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localcreditamount ELSE 0 END ) DFFS \n" +
                    "\tFROM\n" +
                    "\t\tgl_detail gl_detail\n" +
                    "\t\tLEFT JOIN gl_docfree1 ON gl_detail.assid = gl_docfree1.assid\n" +
                    "\t\tLEFT JOIN org_dept ON gl_docfree1.f1 = org_dept.pk_dept\n" +
                    "\t\tLEFT JOIN bd_project ON gl_docfree1.f10 = bd_project.pk_project\n" +
                    "\t\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
                    "\t\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
                    "\t\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
                    "\tWHERE\n" +
                    "\t\tsubstring( bd_account.CODE, 0, 5 ) IN ('5001') \n" +
                    "\t\tAND gl_detail.yearv = '"+year+"' \n" +
                    "\t\tAND gl_detail.adjustperiod = '"+month+"' \n" +
                    "\t\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
                    "\t\tAND gl_detail.discardflagv <> 'Y' \n" +
                    "\t\tAND gl_detail.dr = 0 \n" +
                    "\t\tAND gl_detail.voucherkindv <> 255 \n" +
                    "\t\tAND gl_detail.tempsaveflag <> 'Y' \n" +
                    "\t\tAND gl_detail.voucherkindv <> 5 \n" +
                    "\t\tAND ( gl_docfree1.F1 <> 'NN/A' OR gl_docfree1.F10 <> 'NN/A' ) \n" +
                    "\t\tAND 1 = 1 \n" +
                    "\tGROUP BY\n" +
                    "\t\tgl_detail.pk_accasoa,\n" +
                    "\t\tgl_detail.pk_accountingbook,\n" +
                    "\t\tgl_detail.yearv,\n" +
                    "\t\tgl_detail.adjustperiod,\n" +
                    "\t\torg_dept.CODE,\n" +
                    "\t\torg_dept.NAME,\n" +
                    "\t\torg_accountingbook.CODE,\n" +
                    "\t\torg_accountingbook.NAME,\n" +
                    "\t\tbd_accasoa.dispname,\n" +
                    "\t\tbd_account.CODE,\n" +
                    "\t\tbd_project.project_code,\n" +
                    "\t\tbd_project.project_name \n" +
                    "\t) A \n" +
                    "GROUP BY\n" +
                    "\tA.yearv,\n" +
                    "\tA.monthv,\n" +
                    "\tA.xmcode,\n" +
                    "\tA.xmname \n" +
                    "ORDER BY\n" +
                    "\txmcode ASC";

            resultSet = statement.executeQuery(sql);
            List<Map<String,Object>> otherList = new ArrayList<>();
            while (resultSet.next()) {
                HashMap<String, Object> personCost = new HashMap<>();
                personCost.put("xmcode",resultSet.getString("xmcode"));
                personCost.put("xmname",resultSet.getString("xmname"));
                personCost.put("other_compute",resultSet.getString("JFFS"));
                otherList.add(personCost);
            }
            log.info("otherList:{}",otherList.size());

            //管理费用分子6601+6602+6603
            sql = "SELECT\n" +
                    "\tsum( A.JFFS ) JFFS,\n" +
                    "\tsum( A.DFFS ) DFFS \n" +
                    "FROM\n" +
                    "\t(\n" +
                    "\tSELECT\n" +
                    "\t\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localdebitamount ELSE 0 END ) JFFS,\n" +
                    "\t\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localcreditamount ELSE 0 END ) DFFS \n" +
                    "\tFROM\n" +
                    "\t\tgl_detail gl_detail\n" +
                    "\t\tLEFT JOIN gl_docfree1 ON gl_detail.assid = gl_docfree1.assid\n" +
                    "\t\tLEFT JOIN org_dept ON gl_docfree1.f1 = org_dept.pk_dept\n" +
                    "\t\tLEFT JOIN bd_project ON gl_docfree1.f10 = bd_project.pk_project\n" +
                    "\t\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
                    "\t\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
                    "\t\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
                    "\tWHERE\n" +
                    "\t\t substring( bd_account.CODE, 0, 5 ) IN ( '6602', '6601' ) \n" +
                    "\t\tAND bd_account.CODE != '660248' \n" +
                    "\t\tAND gl_detail.yearv = '"+year+"' \n" +
                    "\t\tAND gl_detail.adjustperiod = '"+month+"' \n" +
                    "\t\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
                    "\t\tAND gl_detail.discardflagv <> 'Y' \n" +
                    "\t\tAND gl_detail.dr = 0 \n" +
                    "\t\tAND gl_detail.voucherkindv <> 255 \n" +
                    "\t\tAND gl_detail.tempsaveflag <> 'Y' \n" +
                    "\t\tAND gl_detail.voucherkindv <> 5 \n" +
                    "\t\tAND ( gl_docfree1.F1 <> 'NN/A' OR gl_docfree1.F10 <> 'NN/A' ) \n" +
//                    "\t\tUNION ALL\n" +
//                    "\tSELECT\n" +
//                    "\t\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localdebitamount ELSE 0 END ) JFFS,\n" +
//                    "\t\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localcreditamount ELSE 0 END ) DFFS \n" +
//                    "\tFROM\n" +
//                    "\t\tgl_detail gl_detail\n" +
//                    "\t\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
//                    "\t\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
//                    "\t\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
//                    "\tWHERE\n" +
//                    "\t\tsubstring( bd_account.CODE, 0, 5 ) IN ( '6603' ) \n" +
//                    "\t\tAND gl_detail.yearv = '"+year+"' \n" +
//                    "\t\tAND gl_detail.adjustperiod = '"+month+"' \n" +
//                    "\t\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
//                    "\t\tAND gl_detail.discardflagv <> 'Y' \n" +
//                    "\t\tAND gl_detail.dr = 0 \n" +
//                    "\t\tAND gl_detail.voucherkindv <> 255 \n" +
//                    "\t\tAND gl_detail.tempsaveflag <> 'Y' \n" +
//                    "\t\tAND gl_detail.voucherkindv <> 5 \n" +
//                    "\tAND 1 = 1 \n" +
                    "\t)A";

            resultSet = statement.executeQuery(sql);
            List<Map<String,Object>> manageList = new ArrayList<>();
            while (resultSet.next()) {
                HashMap<String, Object> personCost = new HashMap<>();
                personCost.put("manage_compute",resultSet.getString("JFFS"));
                manageList.add(personCost);
            }
            log.info("manageList:{}",manageList.size());

            //管理费用分母
            sql = "SELECT\n" +
                    "\tbd_project.project_code xmcode,\n" +
                    "\tbd_project.project_name xmname,\n" +
                    "\tgl_detail.yearv yearv,\n" +
                    "\tgl_detail.adjustperiod monthv,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localdebitamount ELSE 0 END ) JFFS,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localcreditamount ELSE 0 END ) DFFS \n" +
                    "FROM\n" +
                    "\tgl_detail gl_detail\n" +
                    "\tLEFT JOIN gl_docfree1 ON gl_detail.assid = gl_docfree1.assid\n" +
                    "\tLEFT JOIN org_dept ON gl_docfree1.f1 = org_dept.pk_dept\n" +
                    "\tLEFT JOIN bd_project ON gl_docfree1.f10 = bd_project.pk_project\n" +
                    "\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
                    "\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
                    "\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
                    "WHERE\n" +
                    "\tbd_account.CODE IN ( '600101','600109','600102','600106','600103') \n" +
                    "\tAND gl_detail.yearv = '"+year+"' \n" +
                    "\tAND gl_detail.adjustperiod = '"+month+"' \n" +
                    "\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
                    "\tAND gl_detail.discardflagv <> 'Y' \n" +
                    "\tAND gl_detail.dr = 0 \n" +
                    "\tAND gl_detail.voucherkindv <> 255 \n" +
                    "\tAND gl_detail.tempsaveflag <> 'Y' \n" +
                    "\tAND gl_detail.voucherkindv <> 5 \n" +
                    "\tAND ( gl_docfree1.F1 <> 'NN/A' OR gl_docfree1.F10 <> 'NN/A' ) \n" +
                    "\tAND 1 = 1 \n" +
                    "GROUP BY\n" +
                    "\tgl_detail.yearv,\n" +
                    "\tgl_detail.adjustperiod,\n" +
                    "\tbd_project.project_code,\n" +
                    "\tbd_project.project_name \n" +
                    "ORDER BY\n" +
                    "\txmcode ASC ";

            resultSet = statement.executeQuery(sql);
            List<Map<String,Object>> manageProjectList = new ArrayList<>();
            while (resultSet.next()) {
                HashMap<String, Object> personCost = new HashMap<>();
                personCost.put("xmcode",resultSet.getString("xmcode"));
                personCost.put("xmname",resultSet.getString("xmname"));
                personCost.put("manage_project_compute",resultSet.getString("JFFS"));
                manageProjectList.add(personCost);
            }
            log.info("manageProjectList:{}",manageProjectList.size());

            //企业所得税6801
/*            sql = "SELECT\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localdebitamount ELSE 0 END ) JFFS,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localcreditamount ELSE 0 END ) DFFS \n" +
                    "FROM\n" +
                    "\tgl_detail gl_detail\n" +
                    "\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
                    "\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
                    "\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
                    "WHERE\n" +
                    "\tsubstring ( bd_account.CODE, 0, 5 ) IN ( '6801' ) \n" +
                    "\tAND gl_detail.yearv = '"+year+"' \n" +
                    "\tAND gl_detail.adjustperiod = '"+month+"' \n" +
                    "\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
                    "\tAND gl_detail.discardflagv <> 'Y' \n" +
                    "\tAND gl_detail.dr = 0 \n" +
                    "\tAND gl_detail.voucherkindv <> 255 \n" +
                    "\tAND gl_detail.tempsaveflag <> 'Y' \n" +
                    "\tAND gl_detail.voucherkindv <> 5 ";


            resultSet = statement.executeQuery(sql);
            List<Map<String,Object>> businessIncomeList = new ArrayList<>();
            while (resultSet.next()) {
                HashMap<String, Object> personCost = new HashMap<>();
                personCost.put("business_income_compute",resultSet.getString("JFFS"));
                businessIncomeList.add(personCost);
            }
            log.info("businessIncomeList:{}",businessIncomeList.size());*/
//            1709222400

            //所有项目点
            List<Map> dataList = ydService.queryFormData_all(YDParam.builder()
                    .appType("APP_ERBDTFS82HOVBPL3NFH0")
                    .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                    .formUuid("FORM-97BA6C6C8C50416A9E5854F2F4B5C3F3R4WC")
                    .build());

            //算薪人数
            String status = "2,3,5,-1";
            List<String> filterList = new ArrayList<>();
            filterList.add("sys00-dept");
            filterList.add("sys00-mainDept");
            List<String> workingEmployeeIds = ddClientPersonnel.getWorkingEmployeeIds(ddClient.getAccessToken(), status);
            List<Map> employeeInfos = ddClientPersonnel.getEmployeeInfos(ddClient.getAccessToken(), workingEmployeeIds, agentId, filterList);
            List<String> personList = new ArrayList<>();
            employeeInfos.forEach(e->{
                List<Map> mapList = (List<Map>) e.get("field_data_list");
                mapList.forEach(m->{
                    if ("sys00-dept".equals(m.get("field_code"))){
                        List<Map> valueList = (List<Map>) m.get("field_value_list");
                        String value = valueList.get(0).get("value").toString();
                        personList.add(value);
                    }
                });
            });
            Map<String, Long> collect = personList.stream().collect(Collectors.groupingBy(i -> i, Collectors.counting()));

//            log.info("collect:{}",collect);
            final Double[] zsdglfy = {0.0};
            final Double[] zsdsum = {0.0};
            //直属队
            List<Map> zsd = ydService.queryFormData_all(YDParam.builder()
                    .appType("APP_ERBDTFS82HOVBPL3NFH0")
                    .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                    .formUuid("FORM-97BA6C6C8C50416A9E5854F2F4B5C3F3R4WC")
                    .searchCondition(JSON.toJSONString(UtilMap.map("textField_lrr3rg6i","直属队")))
                    .build());
            zsd.forEach(e->{
                if (ObjectUtil.isNotNull(manageList) && manageList.size() > 0){
                    manageList.forEach(s->{
//                        log.info("manage_compute数据:{}",s.get("manage_compute"));
                        double manage_compute = s.get("manage_compute") == null || s.get("manage_compute").toString().isEmpty() ? 0.0 : Double.parseDouble(s.get("manage_compute").toString());
                        zsdsum[0] = zsdsum[0] + manage_compute;
                    });
                    if (workingEmployeeIds.size() == 0 || workingEmployeeIds.size() * zsdsum[0] == 0.0){
                        zsdglfy[0] = 0.0;
                    }else {
                        zsdglfy[0] = zsdglfy[0] + (collect.get("工程部（直属队）")==null||collect.get("工程部（直属队）").toString().isEmpty()?0.0:Double.parseDouble(collect.get("工程部（直属队）").toString()) )/ zsdsum[0];
                    }
                }
            });

            log.info("zsdglfy[0]:{}",zsdglfy[0]);
            List<Map> projectList = new ArrayList<>();
            dataList = dataList.stream().filter(e -> !"PM99006".equals(e.get("textField_ltxrn8h1")) && !"PM99016".equals(e.get("textField_ltxrn8h1")) && !"PM99014".equals(e.get("textField_ltxrn8h1"))).collect(Collectors.toList());
            dataList.forEach(e-> {
                List<Map> tableList = ydService.queryDetails(YDParam.builder().
                        appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formInstanceId(e.get("formInstanceId").toString())
                        .formUuid("FORM-97BA6C6C8C50416A9E5854F2F4B5C3F3R4WC")
                        .tableFieldId("tableField_lrru2tnq")
                        .build());
                tableList = tableList.stream().filter(item -> yearAndMonth.equals(item.get("textField_luh0k82j"))).collect(Collectors.toList());
                if (!tableList.isEmpty()){
                    projectList.addAll(tableList);
                }
            });
            Double sumProject = projectList.size()==0?0.0:projectList.stream().filter(item -> ((item.get("numberField_lryopn7o_value")!= null && item.get("numberField_lrru2to2_value") != null)||((!item.get("numberField_lryopn7o_value").toString().isEmpty()) && (!item.get("numberField_lrru2to2_value").toString().isEmpty())))).map(e -> "0".equals(e.get("numberField_lrru2to2_value")) || "".equals(e.get("numberField_lrru2to2_value")) ? Double.parseDouble("".equals(e.get("numberField_lryopn7o_value")) ?"0.0":e.get("numberField_lryopn7o_value").toString()) : Double.parseDouble(e.get("numberField_lrru2to2_value").toString())).reduce(0.0, Double::sum);
            Double sumSamll = projectList.size()==0?0.0:projectList.stream().filter(item -> (item.get("numberField_m5uf580r_value")!= null && !item.get("numberField_m5uf580r_value").toString().isEmpty())).map(e -> Double.parseDouble(e.get("numberField_m5uf580r_value").toString())).reduce(0.0, Double::sum);
            log.info("sumProject:{}",sumProject);
            log.info("sumSamll:{}",sumSamll);
            projectList.clear();
            zsd = dataList.stream().filter(e -> !"直属队".equals(e.get("textField_lrr3rg6i")) && "自营".equals(e.get("selectField_m8851bpp"))).collect(Collectors.toList());
            zsd.forEach(e-> {
                List<Map> tableList = ydService.queryDetails(YDParam.builder().
                        appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formInstanceId(e.get("formInstanceId").toString())
                        .formUuid("FORM-97BA6C6C8C50416A9E5854F2F4B5C3F3R4WC")
                        .tableFieldId("tableField_lrru2tnq")
                        .build());
                tableList = tableList.stream().filter(item -> yearAndMonth.equals(item.get("textField_luh0k82j"))).collect(Collectors.toList());
                if (!tableList.isEmpty()){
                    projectList.addAll(tableList);
                }
            });
            Double exceptZSDIncome = projectList.size()==0?0.0:projectList.stream().filter(item -> ((item.get("numberField_lryopn7o_value")!= null && item.get("numberField_lrru2to2_value") != null)||((!item.get("numberField_lryopn7o_value").toString().isEmpty()) && (!item.get("numberField_lrru2to2_value").toString().isEmpty())))).map(e -> "0".equals(e.get("numberField_lrru2to2_value")) || "".equals(e.get("numberField_lrru2to2_value")) ? Double.parseDouble("".equals(e.get("numberField_lryopn7o_value")) ?"0.0":e.get("numberField_lryopn7o_value").toString()) : Double.parseDouble(e.get("numberField_lrru2to2_value").toString())).reduce(0.0, Double::sum);

            String delete = "DELETE \n" +
                    "FROM\n" +
                    " `lanyun_project_analysis_copy1` \n" +
                    "WHERE\n" +
                    " monthString = '"+ yearAndMonth +"'";

            PreparedStatement preparedStatement = mysqlCon.prepareStatement(delete);
            preparedStatement.execute();

            String insert = "INSERT INTO `dingtalk`.`lanyun_project_analysis_copy1`(`project_name`, `belong_project`, `month`, `status`, `predict_income`, " +
                    "`open`, `income`, `person`, `person_cost`, `material`, `other_cost`, `cost_sum`, `taxes`, `gross_profit`, `gross_margin`, `overhead`, " +
                    "`corporate_income_tax`, `net_profit`, `net_margin`, `format`, `customer_system`, `profit_loss`, `approach_date`, `level`, `notes`, " +
                    "`monthString`, `small_income`, `six`, `sum`, `folding_repair`, `project_code`) " +
                    "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?) ";
            ps[0] = mysqlCon.prepareStatement(insert);

            dataList.forEach(e-> {
                List<Map> tableList = ydService.queryDetails(YDParam.builder().
                        appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formInstanceId(e.get("formInstanceId").toString())
                        .formUuid("FORM-97BA6C6C8C50416A9E5854F2F4B5C3F3R4WC")
                        .tableFieldId("tableField_lrru2tnq")
                        .build());
                tableList = tableList.stream().filter(item -> yearAndMonth.equals(item.get("textField_luh0k82j"))).collect(Collectors.toList());
                String code = e.get("textField_ltxrn8h1").toString();
                String name = e.get("textField_lrr3rg6i").toString();
//                int personCount = e.get("numberField_lrpvi1wf_value") == null || e.get("numberField_lrpvi1wf_value").toString().isEmpty() ? 0 : Integer.parseInt(e.get("numberField_lrpvi1wf_value").toString());
//                log.info("项目点名称：{}",name);
                final Double[] sum = {0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0};
                final Integer[] person = {0};
//                person[0] = person[0] + personCount;
                if (!tableList.isEmpty()) {
                    tableList.forEach(t -> {
                        double open = t.get("numberField_lrru2to2_value") == null || t.get("numberField_lrru2to2_value").toString().isEmpty() ? 0.0 : Double.parseDouble(t.get("numberField_lrru2to2_value").toString());
                        double income = open == 0.0 ? Double.parseDouble("".equals(t.get("numberField_lryopn7o_value")) ? "0.0" : t.get("numberField_lryopn7o_value").toString()) : open;
                        //小业主预估
                        double small = (t.get("numberField_m5uf580r_value") == null || t.get("numberField_m5uf580r_value").toString().isEmpty()) ? 0f : Double.parseDouble(t.get("numberField_m5uf580r_value").toString());
                        //总计人数
                        sum[7] = sum[7] + income;
                        sum[8] = sum[8] + open;
                        sum[0] = sum[0] + small;
                    });
                }

                if (sum[7] > 0.0) {

//                }
//                //小业主合同月金额数据
//                if (ObjectUtil.isNotNull(smallList)){
//                    smallList.forEach(s->{
//                        if (code.equals(s.get("textField_lrnc4owh"))){
//                            double monthAmount = "".equals(s.get("numberField_lrnc4oxe_value")) ? 0.0 : Double.parseDouble(s.get("numberField_lrnc4oxe_value").toString());
//                            sum[0] = sum[0] + monthAmount;
//                        }
//                    });
//                }
//                //算薪人数
                    if (ObjectUtil.isNotNull(collect)) {
                        person[0] = ObjectUtil.isNotNull(collect.get(name)) ? Math.toIntExact(collect.get(name)) : 0;
                    }
                    //生产成本-工资
                    if (ObjectUtil.isNotNull(personCostList)) {
                        personCostList.forEach(s -> {
                            if (code.equals(s.get("xmcode"))) {
                                double person_cost_compute = s.get("person_cost_compute") == null ? 0.0 : Double.parseDouble(s.get("person_cost_compute").toString());
                                sum[1] = sum[1] + person_cost_compute;
                            }
                        });
                    }
                    //500114,500115生产成本-材料费
                    if (ObjectUtil.isNotNull(materialList)) {
                        materialList.forEach(s -> {
                            if (code.equals(s.get("xmcode"))) {
                                double material_compute = s.get("material_compute") == null ? 0.0 : Double.parseDouble(s.get("material_compute").toString());
                                sum[2] = sum[2] + material_compute;
                            }
                        });
                    }
                    //500118,500119,500120,500121生产成本-折修
                    if (ObjectUtil.isNotNull(repairList)) {
                        repairList.forEach(s -> {
                            if (code.equals(s.get("xmcode"))) {
                                double material_compute = s.get("material_compute") == null ? 0.0 : Double.parseDouble(s.get("material_compute").toString());
                                sum[9] = sum[9] + material_compute;
                            }
                        });
                    }
                    //5001生产成本-其他
                    if (ObjectUtil.isNotNull(otherList)) {
                        otherList.forEach(s -> {
                            if (code.equals(s.get("xmcode"))) {
                                double other_compute = s.get("other_compute") == null ? 0.0 : Double.parseDouble(s.get("other_compute").toString());
                                sum[3] = sum[3] + other_compute;
                            }
                        });
                    }
                    //6001+6002+6003 管理费用分子（去掉6003）
                    if (ObjectUtil.isNotNull(manageList)) {
                        manageList.forEach(s -> {
                            double manage_compute = s.get("manage_compute") == null ? 0.0 : Double.parseDouble(s.get("manage_compute").toString());
                            sum[4] = sum[4] + manage_compute;
                        });
                    }
                    //600101+600102+600103+600106+600109 管理费用分母
                    if (ObjectUtil.isNotNull(manageProjectList)) {
                        manageProjectList.forEach(s -> {
                            if (code.equals(s.get("xmcode"))) {
                                double manage_project_compute = s.get("manage_project_compute") == null ? 0.0 : Double.parseDouble(s.get("manage_project_compute").toString());
                                sum[5] = sum[5] + manage_project_compute;
                            }
                        });
                    }
                    //6801企业所得税
/*                if(ObjectUtil.isNotNull(businessIncomeList)){
                    businessIncomeList.forEach(s->{
//                        if (code.equals(s.get("xmcode"))) {
                        double business_income_compute = s.get("business_income_compute") == null ? 0.0 : Double.parseDouble(s.get("business_income_compute").toString());
                        sum[6] = sum[6] + business_income_compute;
//                        }
                    });
                }*/

                    try {
                        ps[0].setObject(1, name);
                        ps[0].setObject(2, null);
                        ps[0].setObject(3, UtilDateTime.parse(yearAndMonth, "yyyy-MM").getTime());
                        ps[0].setObject(4, e.get("selectField_lrn2oy4a") == null ? null : e.get("selectField_lrn2oy4a").toString());
                        ps[0].setObject(5, sum[7]/*/1.06*/ / 10000); //预估
                        ps[0].setObject(6, sum[8]/*/1.06*/ / 10000); //开票
                        ps[0].setObject(7, (sum[7] + sum[0])/*/1.06*/ / 10000);//收入
                        ps[0].setObject(8, person[0]);//人数
                        ps[0].setObject(9, sum[1] / 10000);
                        ps[0].setObject(10, sum[2] / 10000);
                        ps[0].setObject(11, (sum[3] - sum[2] - sum[1] - sum[9]) / 10000);
                        ps[0].setObject(12, sum[3] / 10000);
                        ps[0].setObject(13, (sum[7] + sum[0]) * 0.066/*/1.06*/ / 10000);
                        ps[0].setObject(14, ((sum[7] + sum[0]) / 1.06 - sum[3]) / 10000);
                        ps[0].setObject(15, (sum[7] + sum[0]) == 0.0 ? 0.0 : (sum[7] + sum[0] - sum[3]) / (sum[7] + sum[0]));
                        double glfy = 0.0;
                        double corporate_income_tax = (sum[7] + sum[0]) / 10000 * 0.01;
                        if ("直属队".equals(name)) {
                            glfy = zsdglfy[0];
                        } else {
                            //除直属队外项目的管理费用分摊，项目点收入 /（去除直属队、去除运作模式=整体外包的项目收入合计）*（管理费用合计-直属队管理费用）；
                            glfy = sum[7] / exceptZSDIncome * zsdsum[0];
                        }
//                    if ((sumProject+sumSamll) != 0.0){
//                        corporate_income_tax = (sum[7]+sum[0])/(sumProject+sumSamll)*sum[6];
//                        glfy = sum[4]/(sumProject+sumSamll)*(sum[7]+sum[0]);
//                    }
                        ps[0].setObject(16, glfy / 10000);
                        //企业所得税corporate_income_tax
                        ps[0].setObject(17, corporate_income_tax / 10000);
                        ps[0].setObject(18, ((sum[7] + sum[0])/* / 1.06*/ - sum[3] - glfy - corporate_income_tax) / 10000);
                        double net_margin = (sum[7] + sum[0]) == 0.0 ? 0.0 : (sum[7] + sum[0] - sum[3] - glfy - corporate_income_tax) / (sum[7] + sum[0]);
                        ps[0].setObject(19, net_margin);
                        String profit_loss = "";
                        if (net_margin < 0) {
                            profit_loss = "亏损";
                        } else if (net_margin >= 0 && net_margin <= 0.05) {
                            profit_loss = "净利较低";
                        } else if (net_margin > 0.05) {
                            profit_loss = "盈利";
                        }
                        ps[0].setObject(20, e.get("selectField_lrhjdu45") == null ? null : e.get("selectField_lrhjdu45").toString());
                        ps[0].setObject(21, e.get("textField_lrn2oy4n") == null ? null : e.get("textField_lrn2oy4n").toString());
                        ps[0].setObject(22, profit_loss);
                        ps[0].setObject(23, e.get("dateField_lrn2oy54") == null ? null : e.get("dateField_lrn2oy54").toString());
                        ps[0].setObject(24, e.get("selectField_ltfgfke7") == null ? null : e.get("selectField_ltfgfke7").toString());
                        ps[0].setObject(25, "");
                        ps[0].setObject(26, yearAndMonth);
                        ps[0].setObject(27, sum[0]);
                        ps[0].setObject(28, sum[6]);
                        ps[0].setObject(29, sumProject + sumSamll);
                        ps[0].setObject(30, sum[9] / 10000);
                        ps[0].setObject(31, code);

                        ps[0].addBatch();
                    } catch (SQLException ex) {
                        ex.printStackTrace();
                    }
//                }
                }
            });
            ps[0].executeBatch();

        } catch (Exception e) {
            e.printStackTrace();
            log.info("数据库连接异常"+e.toString());
        } finally {
            // 关闭资源
            try {
                if (resultSet != null) resultSet.close();
                if (mysqlCon != null) mysqlCon.close();
                if (statement != null) statement.close();
                if (connection != null) connection.close();

            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }

    @Override
    public void ncToYiDa() {
        int year = lastMonth.getYear();
        String month = String.format("%02d",lastMonth.getMonthValue()) ;
        String yearAndMonth = year +"-"+month;

        String sql = "SELECT\n" +
                "\t* \n" +
                "FROM\n" +
                "\t`lanyun_project_analysis_copy1` \n" +
                "WHERE\n" +
                "\tmonthString >= '"+ yearAndMonth +"' \n" +
                "\tAND is_cogradient = '否' \n" +
                "\tAND income + person + cost_sum + overhead > 0";
        Connection connection = null;
        Statement statement = null;
        PreparedStatement ps = null;
        ResultSet resultSet = null;
        List<String> ids = new ArrayList<>();
        try {
            connection = DriverManager.getConnection(mySqlBean.getUrl(), mySqlBean.getUsername(), mySqlBean.getPassword());
            statement = connection.createStatement();
            resultSet = statement.executeQuery(sql);
            while (resultSet.next()){
                Map<String, Object> map = new HashMap<>();
                map.put("textField_dliiyul",resultSet.getString("project_name"));
                map.put("textField_bheotm5",resultSet.getString("belong_project"));
                map.put("dateField_lcwv382",resultSet.getString("month"));
                map.put("textField_pa6o780",resultSet.getString("status"));
                map.put("numberField_5wyyb42",resultSet.getString("predict_income"));
                map.put("numberField_c4acnrg",resultSet.getString("open"));
                map.put("numberField_zjdki9k",resultSet.getString("income"));
                map.put("numberField_hg6jznm",resultSet.getString("person"));
                map.put("numberField_7ga9c5w",resultSet.getString("person_cost"));
                map.put("numberField_c3cqsfv",resultSet.getString("material"));
                map.put("numberField_m7a8qfru",resultSet.getString("folding_repair"));
                map.put("numberField_avaexyf",resultSet.getString("other_cost"));
                map.put("numberField_gub2ul5",resultSet.getString("cost_sum"));
                map.put("numberField_hqiac12",resultSet.getString("taxes"));
                map.put("numberField_lz6mt3xq",resultSet.getString("gross_profit"));
                map.put("numberField_lz9n3fm9",resultSet.getString("gross_margin"));
                map.put("numberField_ln701sy",resultSet.getString("overhead"));
                map.put("numberField_fmhzxdr",resultSet.getString("corporate_income_tax"));
                map.put("numberField_lz6mt3xr",resultSet.getString("net_profit"));
                map.put("numberField_lz9n3fma",resultSet.getString("net_margin"));
                map.put("textField_tpb3m2f",resultSet.getString("format"));
                map.put("textField_2adicsn",resultSet.getString("customer_system"));
                map.put("textField_1yw4mx4",resultSet.getString("profit_loss"));
                map.put("dateField_ji5yfvf",resultSet.getString("approach_date"));
                map.put("textField_h2qx5nz",resultSet.getString("level"));
                map.put("textField_35paoph",resultSet.getString("notes"));

                String id = resultSet.getString("id");
                ids.add(id);

                ydClient.operateData(YDParam.builder()
                        .appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
//                        .formUuid("FORM-946B7B31D7FD45268DA992681F81F619FFVC")
                        .formUuid("FORM-954C78969A864D95A1BC0CE9F69299E8VI38")
                        .formDataJson(JSON.toJSONString(map))
                        .build(), YDConf.FORM_OPERATION.create);
            }
            String join = "('" + String.join("','", ids) + "')";
            sql = "UPDATE `lanyun_project_analysis_copy1` SET is_cogradient = '是' WHERE id in "+ join +"";
            ps = connection.prepareStatement(sql);
            ps.execute();
        } catch (SQLException e) {
            log.info("数据库执行失败：{}",e);
        }finally {
            try {
                statement.close();
                ps.close();
                connection.close();
            } catch (SQLException e) {
                log.info("数据库关闭失败");
                throw new RuntimeException(e);
            }
        }

    }

    private void deleteMonthDate(String formUuid,String key, String year, String month){
        String yearAndMonth = year;
        if (ObjectUtil.isNotNull(month)){
            yearAndMonth = yearAndMonth + "-" + month;
        }
        List<Map> allProjectList = ydService.queryFormData_all(YDParam.builder()
                .appType("APP_ERBDTFS82HOVBPL3NFH0")
                .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                .formUuid(formUuid)
                .searchFieldJson(JSON.toJSONString(UtilMap.map(key, yearAndMonth)))
                .build());
        allProjectList.forEach(e->{
            ydClient.operateData(YDParam.builder()
                    .appType("APP_ERBDTFS82HOVBPL3NFH0")
                    .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                    .formInstanceId(e.get("formInstanceId").toString())
                    .build(), YDConf.FORM_OPERATION.delete);
        });
    }

    @Override
    public void getByMonth(Map data) {
        int year = Integer.parseInt(data.get("year").toString());
        String month = data.get("month").toString() ;
        String yearAndMonth = year +"-"+month;


        Connection connection = null;
        Statement statement = null;
        ResultSet resultSet = null;
        Connection mysqlCon = null;
        PreparedStatement[] ps = {null};
        try {
            // 加载 JDBC 驱动
            Class.forName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
            // 建立连接
            connection = DriverManager.getConnection(sqlBean.getUrl(), sqlBean.getUsername(), sqlBean.getPassword());
            mysqlCon = DriverManager.getConnection(mySqlBean.getUrl(), mySqlBean.getUsername(), mySqlBean.getPassword());

            // 创建 Statement 对象
            statement = connection.createStatement();

            //获取生产成本-工资
            String sql = "SELECT\n" +
                    "\tbd_project.project_code xmcode,\n" +
                    "\tbd_project.project_name xmname,\n" +
                    "\tgl_detail.yearv yearv,\n" +
                    "\tgl_detail.adjustperiod monthv,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localdebitamount ELSE 0 END ) JFFS,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localcreditamount ELSE 0 END ) DFFS \n" +
                    "FROM\n" +
                    "\tgl_detail gl_detail\n" +
                    "\tLEFT JOIN gl_docfree1 ON gl_detail.assid = gl_docfree1.assid\n" +
                    "\tLEFT JOIN org_dept ON gl_docfree1.f1 = org_dept.pk_dept\n" +
                    "\tLEFT JOIN bd_project ON gl_docfree1.f10 = bd_project.pk_project\n" +
                    "\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
                    "\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
                    "\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
                    "WHERE\n" +
                    "\tbd_account.CODE IN ( '50010101', '500103', '500102', '500117' ) \n" +
                    "\tAND gl_detail.yearv = '"+year+"' \n" +
                    "\tAND gl_detail.adjustperiod = '"+month+"' \n" +
                    "\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
                    "\tAND gl_detail.discardflagv <> 'Y' \n" +
                    "\tAND gl_detail.dr = 0 \n" +
                    "\tAND gl_detail.voucherkindv <> 255 \n" +
                    "\tAND gl_detail.tempsaveflag <> 'Y' \n" +
                    "\tAND gl_detail.voucherkindv <> 5 \n" +
                    "\tAND ( gl_docfree1.F1 <> 'NN/A' OR gl_docfree1.F10 <> 'NN/A' ) \n" +
                    "\tAND 1 = 1 \n" +
                    "GROUP BY\n" +
                    "\tgl_detail.yearv,\n" +
                    "\tgl_detail.adjustperiod,\n" +
                    "\tbd_project.project_code,\n" +
                    "\tbd_project.project_name \n" +
                    "ORDER BY\n" +
                    "\txmcode ASC ";

            resultSet = statement.executeQuery(sql);

            List<Map<String,Object>> personCostList = new ArrayList<>();
            while (resultSet.next()) {
                HashMap<String, Object> personCost = new HashMap<>();
                personCost.put("xmcode",resultSet.getString("xmcode"));
                personCost.put("xmname",resultSet.getString("xmname"));
                personCost.put("person_cost_compute",resultSet.getString("JFFS"));
                personCostList.add(personCost);
            }
            log.info("personCostList:{}",personCostList.size());
            //获取生产成本-材料费
            sql = "SELECT\n" +
                    "\tbd_project.project_code xmcode,\n" +
                    "\tbd_project.project_name xmname,\n" +
                    "\tgl_detail.yearv yearv,\n" +
                    "\tgl_detail.adjustperiod monthv,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localdebitamount ELSE 0 END ) JFFS,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localcreditamount ELSE 0 END ) DFFS \n" +
                    "FROM\n" +
                    "\tgl_detail gl_detail\n" +
                    "\tLEFT JOIN gl_docfree1 ON gl_detail.assid = gl_docfree1.assid\n" +
                    "\tLEFT JOIN org_dept ON gl_docfree1.f1 = org_dept.pk_dept\n" +
                    "\tLEFT JOIN bd_project ON gl_docfree1.f10 = bd_project.pk_project\n" +
                    "\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
                    "\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
                    "\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
                    "WHERE\n" +
                    "\tbd_account.CODE IN ( '500114','500115' ) \n" +
                    "\tAND gl_detail.yearv = '"+year+"' \n" +
                    "\tAND gl_detail.adjustperiod = '"+month+"' \n" +
                    "\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
                    "\tAND gl_detail.discardflagv <> 'Y' \n" +
                    "\tAND gl_detail.dr = 0 \n" +
                    "\tAND gl_detail.voucherkindv <> 255 \n" +
                    "\tAND gl_detail.tempsaveflag <> 'Y' \n" +
                    "\tAND gl_detail.voucherkindv <> 5 \n" +
                    "\tAND ( gl_docfree1.F1 <> 'NN/A' OR gl_docfree1.F10 <> 'NN/A' ) \n" +
                    "\tAND 1 = 1 \n" +
                    "GROUP BY\n" +
                    "\tgl_detail.yearv,\n" +
                    "\tgl_detail.adjustperiod,\n" +
                    "\tbd_project.project_code,\n" +
                    "\tbd_project.project_name \n" +
                    "ORDER BY\n" +
                    "\txmcode ASC ";

            resultSet = statement.executeQuery(sql);
            List<Map<String,Object>> materialList = new ArrayList<>();
            while (resultSet.next()) {
                HashMap<String, Object> personCost = new HashMap<>();
                personCost.put("xmcode",resultSet.getString("xmcode"));
                personCost.put("xmname",resultSet.getString("xmname"));
                personCost.put("material_compute",resultSet.getString("JFFS"));
                materialList.add(personCost);
            }
            log.info("materialList:{}",materialList.size());

            //获取生产成本-折修租劳
            sql = "SELECT\n" +
                    "\tbd_project.project_code xmcode,\n" +
                    "\tbd_project.project_name xmname,\n" +
                    "\tgl_detail.yearv yearv,\n" +
                    "\tgl_detail.adjustperiod monthv,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localdebitamount ELSE 0 END ) JFFS,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localcreditamount ELSE 0 END ) DFFS \n" +
                    "FROM\n" +
                    "\tgl_detail gl_detail\n" +
                    "\tLEFT JOIN gl_docfree1 ON gl_detail.assid = gl_docfree1.assid\n" +
                    "\tLEFT JOIN org_dept ON gl_docfree1.f1 = org_dept.pk_dept\n" +
                    "\tLEFT JOIN bd_project ON gl_docfree1.f10 = bd_project.pk_project\n" +
                    "\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
                    "\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
                    "\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
                    "WHERE\n" +
                    "\tbd_account.CODE IN ( '500118','500119','500120','500121' ) \n" +
                    "\tAND gl_detail.yearv = '"+year+"' \n" +
                    "\tAND gl_detail.adjustperiod = '"+month+"' \n" +
                    "\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
                    "\tAND gl_detail.discardflagv <> 'Y' \n" +
                    "\tAND gl_detail.dr = 0 \n" +
                    "\tAND gl_detail.voucherkindv <> 255 \n" +
                    "\tAND gl_detail.tempsaveflag <> 'Y' \n" +
                    "\tAND gl_detail.voucherkindv <> 5 \n" +
                    "\tAND ( gl_docfree1.F1 <> 'NN/A' OR gl_docfree1.F10 <> 'NN/A' ) \n" +
                    "\tAND 1 = 1 \n" +
                    "GROUP BY\n" +
                    "\tgl_detail.yearv,\n" +
                    "\tgl_detail.adjustperiod,\n" +
                    "\tbd_project.project_code,\n" +
                    "\tbd_project.project_name \n" +
                    "ORDER BY\n" +
                    "\txmcode ASC ";

            resultSet = statement.executeQuery(sql);
            List<Map<String,Object>> repairList = new ArrayList<>();
            while (resultSet.next()) {
                HashMap<String, Object> personCost = new HashMap<>();
                personCost.put("xmcode",resultSet.getString("xmcode"));
                personCost.put("xmname",resultSet.getString("xmname"));
                personCost.put("material_compute",resultSet.getString("JFFS"));
                repairList.add(personCost);
            }
            log.info("materialList:{}",materialList.size());

            //获取5001科目总生产成本
            sql = "SELECT\n" +
                    "\tA.yearv,\n" +
                    "\tA.monthv,\n" +
                    "\tA.xmcode,\n" +
                    "\tA.xmname,\n" +
                    "\tsum( A.JFFS ) JFFS,\n" +
                    "\tsum( A.DFFS ) DFFS \n" +
                    "FROM\n" +
                    "\t(\n" +
                    "\tSELECT\n" +
                    "\t\tgl_detail.yearv yearv,\n" +
                    "\t\tgl_detail.adjustperiod monthv,\n" +
                    "\t\torg_accountingbook.CODE orgcode,\n" +
                    "\t\torg_accountingbook.NAME orgname,\n" +
                    "\t\tsubstring( bd_account.CODE, 0, 5 ) kmbm,\n" +
                    "\t\tbd_accasoa.dispname,\n" +
                    "\t\torg_dept.CODE bmcode,\n" +
                    "\t\torg_dept.NAME bmname,\n" +
                    "\t\tbd_project.project_code xmcode,\n" +
                    "\t\tbd_project.project_name xmname,\n" +
                    "\t\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localdebitamount ELSE 0 END ) JFFS,\n" +
                    "\t\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localcreditamount ELSE 0 END ) DFFS \n" +
                    "\tFROM\n" +
                    "\t\tgl_detail gl_detail\n" +
                    "\t\tLEFT JOIN gl_docfree1 ON gl_detail.assid = gl_docfree1.assid\n" +
                    "\t\tLEFT JOIN org_dept ON gl_docfree1.f1 = org_dept.pk_dept\n" +
                    "\t\tLEFT JOIN bd_project ON gl_docfree1.f10 = bd_project.pk_project\n" +
                    "\t\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
                    "\t\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
                    "\t\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
                    "\tWHERE\n" +
                    "\t\tsubstring( bd_account.CODE, 0, 5 ) IN ('5001') \n" +
                    "\t\tAND gl_detail.yearv = '"+year+"' \n" +
                    "\t\tAND gl_detail.adjustperiod = '"+month+"' \n" +
                    "\t\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
                    "\t\tAND gl_detail.discardflagv <> 'Y' \n" +
                    "\t\tAND gl_detail.dr = 0 \n" +
                    "\t\tAND gl_detail.voucherkindv <> 255 \n" +
                    "\t\tAND gl_detail.tempsaveflag <> 'Y' \n" +
                    "\t\tAND gl_detail.voucherkindv <> 5 \n" +
                    "\t\tAND ( gl_docfree1.F1 <> 'NN/A' OR gl_docfree1.F10 <> 'NN/A' ) \n" +
                    "\t\tAND 1 = 1 \n" +
                    "\tGROUP BY\n" +
                    "\t\tgl_detail.pk_accasoa,\n" +
                    "\t\tgl_detail.pk_accountingbook,\n" +
                    "\t\tgl_detail.yearv,\n" +
                    "\t\tgl_detail.adjustperiod,\n" +
                    "\t\torg_dept.CODE,\n" +
                    "\t\torg_dept.NAME,\n" +
                    "\t\torg_accountingbook.CODE,\n" +
                    "\t\torg_accountingbook.NAME,\n" +
                    "\t\tbd_accasoa.dispname,\n" +
                    "\t\tbd_account.CODE,\n" +
                    "\t\tbd_project.project_code,\n" +
                    "\t\tbd_project.project_name \n" +
                    "\t) A \n" +
                    "GROUP BY\n" +
                    "\tA.yearv,\n" +
                    "\tA.monthv,\n" +
                    "\tA.xmcode,\n" +
                    "\tA.xmname \n" +
                    "ORDER BY\n" +
                    "\txmcode ASC";

            resultSet = statement.executeQuery(sql);
            List<Map<String,Object>> otherList = new ArrayList<>();
            while (resultSet.next()) {
                HashMap<String, Object> personCost = new HashMap<>();
                personCost.put("xmcode",resultSet.getString("xmcode"));
                personCost.put("xmname",resultSet.getString("xmname"));
                personCost.put("other_compute",resultSet.getString("JFFS"));
                otherList.add(personCost);
            }
            log.info("otherList:{}",otherList.size());

            //管理费用分子6601+6602+6603
            sql = "SELECT\n" +
                    "\tsum( A.JFFS ) JFFS,\n" +
                    "\tsum( A.DFFS ) DFFS \n" +
                    "FROM\n" +
                    "\t(\n" +
                    "\tSELECT\n" +
                    "\t\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localdebitamount ELSE 0 END ) JFFS,\n" +
                    "\t\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localcreditamount ELSE 0 END ) DFFS \n" +
                    "\tFROM\n" +
                    "\t\tgl_detail gl_detail\n" +
                    "\t\tLEFT JOIN gl_docfree1 ON gl_detail.assid = gl_docfree1.assid\n" +
                    "\t\tLEFT JOIN org_dept ON gl_docfree1.f1 = org_dept.pk_dept\n" +
                    "\t\tLEFT JOIN bd_project ON gl_docfree1.f10 = bd_project.pk_project\n" +
                    "\t\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
                    "\t\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
                    "\t\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
                    "\tWHERE\n" +
                    "\t\t substring( bd_account.CODE, 0, 5 ) IN ( '6602', '6601' ) \n" +
                    "\t\tAND bd_account.CODE != '660247' \n" +
                    "\t\tAND gl_detail.yearv = '"+year+"' \n" +
                    "\t\tAND gl_detail.adjustperiod = '"+month+"' \n" +
                    "\t\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
                    "\t\tAND gl_detail.discardflagv <> 'Y' \n" +
                    "\t\tAND gl_detail.dr = 0 \n" +
                    "\t\tAND gl_detail.voucherkindv <> 255 \n" +
                    "\t\tAND gl_detail.tempsaveflag <> 'Y' \n" +
                    "\t\tAND gl_detail.voucherkindv <> 5 \n" +
                    "\t\tAND ( gl_docfree1.F1 <> 'NN/A' OR gl_docfree1.F10 <> 'NN/A' ) \n" +
                    "\t\tUNION ALL\n" +
                    "\tSELECT\n" +
                    "\t\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localdebitamount ELSE 0 END ) JFFS,\n" +
                    "\t\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localcreditamount ELSE 0 END ) DFFS \n" +
                    "\tFROM\n" +
                    "\t\tgl_detail gl_detail\n" +
                    "\t\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
                    "\t\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
                    "\t\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
                    "\tWHERE\n" +
                    "\t\tsubstring( bd_account.CODE, 0, 5 ) IN ( '6603' ) \n" +
                    "\t\tAND gl_detail.yearv = '"+year+"' \n" +
                    "\t\tAND gl_detail.adjustperiod = '"+month+"' \n" +
                    "\t\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
                    "\t\tAND gl_detail.discardflagv <> 'Y' \n" +
                    "\t\tAND gl_detail.dr = 0 \n" +
                    "\t\tAND gl_detail.voucherkindv <> 255 \n" +
                    "\t\tAND gl_detail.tempsaveflag <> 'Y' \n" +
                    "\t\tAND gl_detail.voucherkindv <> 5 \n" +
                    "\tAND 1 = 1 \n" +
                    "\t)A";

            resultSet = statement.executeQuery(sql);
            List<Map<String,Object>> manageList = new ArrayList<>();
            while (resultSet.next()) {
                HashMap<String, Object> personCost = new HashMap<>();
                personCost.put("manage_compute",resultSet.getString("JFFS"));
                manageList.add(personCost);
            }
            log.info("manageList:{}",manageList.size());

            //管理费用分母
            sql = "SELECT\n" +
                    "\tbd_project.project_code xmcode,\n" +
                    "\tbd_project.project_name xmname,\n" +
                    "\tgl_detail.yearv yearv,\n" +
                    "\tgl_detail.adjustperiod monthv,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localdebitamount ELSE 0 END ) JFFS,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localcreditamount ELSE 0 END ) DFFS \n" +
                    "FROM\n" +
                    "\tgl_detail gl_detail\n" +
                    "\tLEFT JOIN gl_docfree1 ON gl_detail.assid = gl_docfree1.assid\n" +
                    "\tLEFT JOIN org_dept ON gl_docfree1.f1 = org_dept.pk_dept\n" +
                    "\tLEFT JOIN bd_project ON gl_docfree1.f10 = bd_project.pk_project\n" +
                    "\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
                    "\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
                    "\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
                    "WHERE\n" +
                    "\tbd_account.CODE IN ( '600101','600109','600102','600106','600103') \n" +
                    "\tAND gl_detail.yearv = '"+year+"' \n" +
                    "\tAND gl_detail.adjustperiod = '"+month+"' \n" +
                    "\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
                    "\tAND gl_detail.discardflagv <> 'Y' \n" +
                    "\tAND gl_detail.dr = 0 \n" +
                    "\tAND gl_detail.voucherkindv <> 255 \n" +
                    "\tAND gl_detail.tempsaveflag <> 'Y' \n" +
                    "\tAND gl_detail.voucherkindv <> 5 \n" +
                    "\tAND ( gl_docfree1.F1 <> 'NN/A' OR gl_docfree1.F10 <> 'NN/A' ) \n" +
                    "\tAND 1 = 1 \n" +
                    "GROUP BY\n" +
                    "\tgl_detail.yearv,\n" +
                    "\tgl_detail.adjustperiod,\n" +
                    "\tbd_project.project_code,\n" +
                    "\tbd_project.project_name \n" +
                    "ORDER BY\n" +
                    "\txmcode ASC ";

            resultSet = statement.executeQuery(sql);
            List<Map<String,Object>> manageProjectList = new ArrayList<>();
            while (resultSet.next()) {
                HashMap<String, Object> personCost = new HashMap<>();
                personCost.put("xmcode",resultSet.getString("xmcode"));
                personCost.put("xmname",resultSet.getString("xmname"));
                personCost.put("manage_project_compute",resultSet.getString("JFFS"));
                manageProjectList.add(personCost);
            }
            log.info("manageProjectList:{}",manageProjectList.size());

            //企业所得税6801
            sql = "SELECT\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localdebitamount ELSE 0 END ) JFFS,\n" +
                    "\tsum( CASE WHEN adjustperiod >= '01' AND adjustperiod <= '12' THEN gl_detail.localcreditamount ELSE 0 END ) DFFS \n" +
                    "FROM\n" +
                    "\tgl_detail gl_detail\n" +
                    "\tLEFT JOIN org_accountingbook ON gl_detail.pk_accountingbook = org_accountingbook.pk_accountingbook\n" +
                    "\tLEFT JOIN bd_accasoa ON gl_detail.pk_accasoa = bd_accasoa.pk_accasoa\n" +
                    "\tLEFT JOIN bd_account ON bd_accasoa.pk_account = bd_account.pk_account \n" +
                    "WHERE\n" +
                    "\tsubstring ( bd_account.CODE, 0, 5 ) IN ( '6801' ) \n" +
                    "\tAND gl_detail.yearv = '"+year+"' \n" +
                    "\tAND gl_detail.adjustperiod = '"+month+"' \n" +
                    "\tAND org_accountingbook.CODE IN ( 'A01-0004', 'A02-0004', 'A11-0004', 'A03-0004', 'A06-0004', 'A04-0004', 'A05-0004', 'A10-0004' ) \n" +
                    "\tAND gl_detail.discardflagv <> 'Y' \n" +
                    "\tAND gl_detail.dr = 0 \n" +
                    "\tAND gl_detail.voucherkindv <> 255 \n" +
                    "\tAND gl_detail.tempsaveflag <> 'Y' \n" +
                    "\tAND gl_detail.voucherkindv <> 5 ";

            resultSet = statement.executeQuery(sql);
            List<Map<String,Object>> businessIncomeList = new ArrayList<>();
            while (resultSet.next()) {
                HashMap<String, Object> personCost = new HashMap<>();
                personCost.put("business_income_compute",resultSet.getString("JFFS"));
                businessIncomeList.add(personCost);
            }
            log.info("businessIncomeList:{}",businessIncomeList.size());
//            1709222400
            List<Map> dataList = ydService.queryFormData_all(YDParam.builder()
                    .appType("APP_ERBDTFS82HOVBPL3NFH0")
                    .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                    .formUuid("FORM-97BA6C6C8C50416A9E5854F2F4B5C3F3R4WC")
                    .build());
            //算薪人数
            String status = "2,3,5,-1";
            List<String> filterList = new ArrayList<>();
            filterList.add("sys00-dept");
            filterList.add("sys00-mainDept");
            List<String> workingEmployeeIds = ddClientPersonnel.getWorkingEmployeeIds(ddClient.getAccessToken(), status);
            List<Map> employeeInfos = ddClientPersonnel.getEmployeeInfos(ddClient.getAccessToken(), workingEmployeeIds, agentId, filterList);
            List<String> personList = new ArrayList<>();
            employeeInfos.forEach(e->{
                List<Map> mapList = (List<Map>) e.get("field_data_list");
                mapList.forEach(m->{
                    if ("sys00-dept".equals(m.get("field_code"))){
                        List<Map> valueList = (List<Map>) m.get("field_value_list");
                        String value = valueList.get(0).get("value").toString();
                        personList.add(value);
                    }
                });
            });
            Map<String, Long> collect = personList.stream().collect(Collectors.groupingBy(i -> i, Collectors.counting()));

            List<Map> projectList = new ArrayList<>();
            dataList.forEach(e-> {
                List<Map> tableList = ydService.queryDetails(YDParam.builder().
                        appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formInstanceId(e.get("formInstanceId").toString())
                        .formUuid("FORM-97BA6C6C8C50416A9E5854F2F4B5C3F3R4WC")
                        .tableFieldId("tableField_lrru2tnq")
                        .build());
                tableList = tableList.stream().filter(item -> yearAndMonth.equals(item.get("textField_luh0k82j"))).collect(Collectors.toList());
                if (!tableList.isEmpty()){
                    projectList.addAll(tableList);
                }
            });
            Double sumProject = projectList.size()==0?0.0:projectList.stream().filter(item -> ((item.get("numberField_lryopn7o_value")!= null && item.get("numberField_lrru2to2_value") != null)||((!item.get("numberField_lryopn7o_value").toString().isEmpty()) && (!item.get("numberField_lrru2to2_value").toString().isEmpty())))).map(e -> "0".equals(e.get("numberField_lrru2to2_value")) || "".equals(e.get("numberField_lrru2to2_value")) ? Double.parseDouble("".equals(e.get("numberField_lryopn7o_value")) ?"0.0":e.get("numberField_lryopn7o_value").toString()) : Double.parseDouble(e.get("numberField_lrru2to2_value").toString())).reduce(0.0, Double::sum);
            Double sumSamll = projectList.size()==0?0.0:projectList.stream().filter(item -> (item.get("numberField_m5uf580r_value")!= null && !item.get("numberField_m5uf580r_value").toString().isEmpty())).map(e -> Double.parseDouble(e.get("numberField_m5uf580r_value").toString())).reduce(0.0, Double::sum);
            log.info("sumProject:{}",sumProject);
            log.info("sumSamll:{}",sumSamll);

            String delete = "DELETE \n" +
                    "FROM\n" +
                    " `lanyun_project_analysis_copy1` \n" +
                    "WHERE\n" +
                    " monthString = '"+ yearAndMonth +"'";

            PreparedStatement preparedStatement = mysqlCon.prepareStatement(delete);
            preparedStatement.execute();

            String insert = "INSERT INTO `dingtalk`.`lanyun_project_analysis_copy1`(`project_name`, `belong_project`, `month`, `status`, `predict_income`, " +
                    "`open`, `income`, `person`, `person_cost`, `material`, `other_cost`, `cost_sum`, `taxes`, `gross_profit`, `gross_margin`, `overhead`, " +
                    "`corporate_income_tax`, `net_profit`, `net_margin`, `format`, `customer_system`, `profit_loss`, `approach_date`, `level`, `notes`, " +
                    "`monthString`, `small_income`, `six`, `sum`, `folding_repair`, `project_code`) " +
                    "VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?) ";
            ps[0] = mysqlCon.prepareStatement(insert);

            dataList.forEach(e->{
                List<Map> tableList = ydService.queryDetails(YDParam.builder().
                        appType("APP_ERBDTFS82HOVBPL3NFH0")
                        .systemToken("RRB66F91T97H1WN89QZYC47PKLZO2ZQOUMOQLP")
                        .formInstanceId(e.get("formInstanceId").toString())
                        .formUuid("FORM-97BA6C6C8C50416A9E5854F2F4B5C3F3R4WC")
                        .tableFieldId("tableField_lrru2tnq")
                        .build());
                tableList = tableList.stream().filter(item -> yearAndMonth.equals(item.get("textField_luh0k82j"))).collect(Collectors.toList());
                String code = e.get("textField_ltxrn8h1").toString();
                String name = e.get("textField_lrr3rg6i").toString();
//                int personCount = e.get("numberField_lrpvi1wf_value") == null || e.get("numberField_lrpvi1wf_value").toString().isEmpty() ? 0 : Integer.parseInt(e.get("numberField_lrpvi1wf_value").toString());
                log.info("项目点名称：{}",name);
                final Double[] sum = {0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0,0.0};
                final Integer[] person = {0};
//                person[0] = person[0] + personCount;
                if (!tableList.isEmpty()){
                    tableList.forEach(t->{
                        double open = t.get("numberField_lrru2to2_value") == null || t.get("numberField_lrru2to2_value").toString().isEmpty() ? 0.0: Double.parseDouble(t.get("numberField_lrru2to2_value").toString());
                        double income = open == 0.0 ? Double.parseDouble("".equals(t.get("numberField_lryopn7o_value")) ?"0.0":t.get("numberField_lryopn7o_value").toString()) : open;
                        //小业主预估
                        double small = (t.get("numberField_m5uf580r_value") == null || t.get("numberField_m5uf580r_value").toString().isEmpty()) ? 0f : Double.parseDouble(t.get("numberField_m5uf580r_value").toString());
                        //总计人数
                        sum[7] = sum[7] + income;
                        sum[8] = sum[8] + open;
                        sum[0] = sum[0] + small;
                    });
                }
//                //小业主合同月金额数据
//                if (ObjectUtil.isNotNull(smallList)){
//                    smallList.forEach(s->{
//                        if (code.equals(s.get("textField_lrnc4owh"))){
//                            double monthAmount = "".equals(s.get("numberField_lrnc4oxe_value")) ? 0.0 : Double.parseDouble(s.get("numberField_lrnc4oxe_value").toString());
//                            sum[0] = sum[0] + monthAmount;
//                        }
//                    });
//                }
//                //算薪人数
                if (ObjectUtil.isNotNull(collect)){
                    person[0] = Math.toIntExact(collect.get(name));
                }
                //生产成本-工资
                if (ObjectUtil.isNotNull(personCostList)){
                    personCostList.forEach(s->{
                        if (code.equals(s.get("xmcode"))){
                            double person_cost_compute = s.get("person_cost_compute") == null ? 0.0 : Double.parseDouble(s.get("person_cost_compute").toString());
                            sum[1] = sum[1] + person_cost_compute;
                        }
                    });
                }
                //500114,500115生产成本-材料费
                if (ObjectUtil.isNotNull(materialList)){
                    materialList.forEach(s->{
                        if (code.equals(s.get("xmcode"))){
                            double material_compute = s.get("material_compute") == null ? 0.0 : Double.parseDouble(s.get("material_compute").toString());
                            sum[2] = sum[2] + material_compute;
                        }
                    });
                }
                //500118,500119,500120,500121生产成本-折修
                if (ObjectUtil.isNotNull(repairList)){
                    repairList.forEach(s->{
                        if (code.equals(s.get("xmcode"))){
                            double material_compute = s.get("material_compute") == null ? 0.0 : Double.parseDouble(s.get("material_compute").toString());
                            sum[9] = sum[9] + material_compute;
                        }
                    });
                }
                //5001生产成本-其他
                if (ObjectUtil.isNotNull(otherList)) {
                    otherList.forEach(s -> {
                        if (code.equals(s.get("xmcode"))) {
                            double other_compute = s.get("other_compute") == null ? 0.0 : Double.parseDouble(s.get("other_compute").toString());
                            sum[3] = sum[3] + other_compute;
                        }
                    });
                }
                //6001+6002+6003 管理费用分子
                if (ObjectUtil.isNotNull(manageList)){
                    manageList.forEach(s->{
                        double manage_compute = s.get("manage_compute") == null ? 0.0 : Double.parseDouble(s.get("manage_compute").toString());
                        sum[4] = sum[4] + manage_compute;
                    });
                }
                //600101+600102+600103+600106+600109 管理费用分母
                if (ObjectUtil.isNotNull(manageProjectList)){
                    manageProjectList.forEach(s->{
                        if (code.equals(s.get("xmcode"))) {
                            double manage_project_compute = s.get("manage_project_compute") == null ? 0.0 : Double.parseDouble(s.get("manage_project_compute").toString());
                            sum[5] = sum[5] + manage_project_compute;
                        }
                    });
                }
                //6801企业所得税
                if(ObjectUtil.isNotNull(businessIncomeList)){
                    businessIncomeList.forEach(s->{
//                        if (code.equals(s.get("xmcode"))) {
                        double business_income_compute = s.get("business_income_compute") == null ? 0.0 : Double.parseDouble(s.get("business_income_compute").toString());
                        sum[6] = sum[6] + business_income_compute;
//                        }
                    });
                }

                try {
                    ps[0].setObject(1,name);
                    ps[0].setObject(2,null);
                    ps[0].setObject(3,UtilDateTime.parse(yearAndMonth,"yyyy-MM").getTime());
                    ps[0].setObject(4,e.get("selectField_lrn2oy4a")==null?null:e.get("selectField_lrn2oy4a").toString());
                    ps[0].setObject(5,sum[7]/*/1.06*//10000); //预估
                    ps[0].setObject(6,sum[8]/*/1.06*//10000); //开票
                    ps[0].setObject(7,(sum[7]+sum[0])/*/1.06*//10000);//收入
                    ps[0].setObject(8,person[0]);//人数
                    ps[0].setObject(9,sum[1]/10000);
                    ps[0].setObject(10,sum[2]/10000);
                    ps[0].setObject(11,(sum[3]-sum[2]-sum[1]-sum[9])/10000);
                    ps[0].setObject(12,sum[3]/10000);
                    ps[0].setObject(13,(sum[7]+sum[0])*0.066/*/1.06*//10000);
                    ps[0].setObject(14,((sum[7]+sum[0])/1.06-sum[3])/10000);
                    ps[0].setObject(15,(sum[7]+sum[0]) == 0.0 ? 0.0:(sum[7]+sum[0]-sum[3])/(sum[7]+sum[0]));
                    double glfy = 0.0;
                    double corporate_income_tax = 0.0;
                    if ((sumProject+sumSamll) != 0.0){
                        corporate_income_tax = (sum[7]+sum[0])/(sumProject+sumSamll)*sum[6];
                        glfy = sum[4]/(sumProject+sumSamll)*(sum[7]+sum[0]);
                    }
                    ps[0].setObject(16,glfy/10000);
                    //企业所得税corporate_income_tax
                    ps[0].setObject(17,corporate_income_tax/10000);
                    ps[0].setObject(18,((sum[7] + sum[0])/* / 1.06*/ - sum[3] - glfy - corporate_income_tax)/10000);
                    double net_margin = (sum[7] + sum[0]) == 0.0 ? 0.0:(sum[7] + sum[0] - sum[3] - glfy - corporate_income_tax) / (sum[7] + sum[0]);
                    ps[0].setObject(19,net_margin);
                    String profit_loss = "";
                    if (net_margin < 0){
                        profit_loss = "亏损";
                    }else if (net_margin >=0 && net_margin <=0.05){
                        profit_loss = "净利较低";
                    }else if(net_margin > 0.05){
                        profit_loss = "盈利";
                    }
                    ps[0].setObject(20,e.get("selectField_lrhjdu45")==null?null:e.get("selectField_lrhjdu45").toString());
                    ps[0].setObject(21,e.get("textField_lrn2oy4n")==null?null:e.get("textField_lrn2oy4n").toString());
                    ps[0].setObject(22,profit_loss);
                    ps[0].setObject(23,e.get("dateField_lrn2oy54")==null?null:e.get("dateField_lrn2oy54").toString());
                    ps[0].setObject(24,e.get("selectField_ltfgfke7")==null?null:e.get("selectField_ltfgfke7").toString());
                    ps[0].setObject(25,"");
                    ps[0].setObject(26, yearAndMonth);
                    ps[0].setObject(27,sum[0]);
                    ps[0].setObject(28,sum[6]);
                    ps[0].setObject(29,sumProject+sumSamll);
                    ps[0].setObject(30,sum[9]/10000);
                    ps[0].setObject(31,code);

                    ps[0].addBatch();
                } catch (SQLException ex) {
                    ex.printStackTrace();
                }
//                }
            });
            ps[0].executeBatch();

        } catch (Exception e) {
            log.info("数据库连接异常"+e.toString());
            e.printStackTrace();
        } finally {
            // 关闭资源
            try {
                if (resultSet != null) resultSet.close();
                if (mysqlCon != null) mysqlCon.close();
                if (statement != null) statement.close();
                if (connection != null) connection.close();

            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }
}
