package com.malk.server.yunjian;

import com.malk.server.common.McException;
import com.malk.server.common.VenR;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Map;

/**
 * 返回值配置参考McR
 */
@Data
@NoArgsConstructor
public class DDR<T> extends VenR {

    // 请求状态
    private String resCode;

    private String resMsg;

    private T data;

    /**
     * token
     */
    private String accessToken;

    // 成功状态标记
    private final static String SUC_CODE = "200000";


    /**
     * 断言错误信息
     */
    @Override
    public void assertSuccess() {
        McException.assertException(!resCode.equals(SUC_CODE), resCode, resMsg, "yunjian");
    }

    /**
     * 通用post请求
     */
    public static DDR doPost(String url, Map header, Map param, Map body) {
        return (DDR) DDR.doPost(url, header, param, body, VenR.RC_YJ);
    }

    /**
     * 通用get请求
     */
    public static DDR doGet(String url, Map header, Map param) {
        return (DDR) DDR.doGet(url, header, param, VenR.RC_YJ);
    }
}
